// Copyright (C) 2005-2006 Code Synthesis Tools CC
//
// This program was generated by XML Schema Definition Compiler (XSD)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// In addition, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef SRGS_PARSER_TEMPLATES_HXX
#define SRGS_PARSER_TEMPLATES_HXX

#include <xsd/cxx/version.hxx>

#if (XSD_INT_VERSION != 2030051L)
#error XSD runtime version mismatch
#endif

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/pre.hxx>

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_PARSER_USE_CHAR
#define XSD_CXX_PARSER_USE_CHAR
#endif

#include <xsd/cxx/parser/exceptions.hxx>
#include <xsd/cxx/parser/elements.hxx>
#include <xsd/cxx/parser/non-validating/parser.hxx>
#include <xsd/cxx/parser/non-validating/types.hxx>
#include <xsd/cxx/parser/xerces/elements.hxx>

namespace xml_schema
{
  namespace parser
  {
    // Generic parser.
    //
#ifndef XSD_CXX_PARSER_XERCES_CHAR_PARSER_IN___XML_SCHEMA__PARSER
#define XSD_CXX_PARSER_XERCES_CHAR_PARSER_IN___XML_SCHEMA__PARSER

    template <typename X>
    struct parser: virtual ::xsd::cxx::parser::parser< X, char >,
    virtual ::xsd::cxx::parser::non_validating::empty_content< char >
    {
    };

    template <typename X>
    struct document: ::xsd::cxx::parser::xerces::document< X, char >
    {
      document (::xsd::cxx::parser::parser< X, char >& p,
                const ::std::basic_string< char >& root_element_name)
      : ::xsd::cxx::parser::xerces::document< X, char > (
        p,
        root_element_name)
      {
      }

      document (::xsd::cxx::parser::parser< X, char >& p,
                const ::std::basic_string< char >& root_element_namespace,
                const ::std::basic_string< char >& root_element_name)
      : ::xsd::cxx::parser::xerces::document< X, char > (
        p,
        root_element_namespace,
        root_element_name)
      {
      }
    };

#endif

    // Parsers for XML Schema built-in types.
    //

    // 8-bit
    //
    typedef ::xsd::cxx::parser::non_validating::byte< char > byte;
    typedef ::xsd::cxx::parser::non_validating::unsigned_byte< char > unsigned_byte;

    // 16-bit
    //
    typedef ::xsd::cxx::parser::non_validating::short_< char > short_;
    typedef ::xsd::cxx::parser::non_validating::unsigned_short< char > unsigned_short;

    // 32-bit
    //
    typedef ::xsd::cxx::parser::non_validating::int_< char > int_;
    typedef ::xsd::cxx::parser::non_validating::unsigned_int< char > unsigned_int;

    // 64-bit
    //
    typedef ::xsd::cxx::parser::non_validating::long_< char > long_;
    typedef ::xsd::cxx::parser::non_validating::unsigned_long< char > unsigned_long;

    // Boolean.
    //
    typedef ::xsd::cxx::parser::non_validating::boolean< char > boolean;

    // Floating-point types.
    //
    typedef ::xsd::cxx::parser::non_validating::float_< char > float_;
    typedef ::xsd::cxx::parser::non_validating::double_< char > double_;
    typedef ::xsd::cxx::parser::non_validating::decimal< char > decimal;

    // String.
    //
    typedef ::xsd::cxx::parser::non_validating::string< char > string;

    // Exceptions. See libxsd/xsd/cxx/parser/exceptions.hxx for details.
    //
    typedef ::xsd::cxx::parser::exception< char > exception;
    typedef ::xsd::cxx::parser::parsing< char > parsing;
    typedef ::xsd::cxx::parser::expected_element< char > expected_element;
    typedef ::xsd::cxx::parser::unexpected_element< char > unexpected_element;
    typedef ::xsd::cxx::parser::expected_attribute< char > expected_attribute;
    typedef ::xsd::cxx::parser::unexpected_attribute< char > unexpected_attribute;
    typedef ::xsd::cxx::parser::unexpected_characters< char > unexpected_characters;
    typedef ::xsd::cxx::parser::invalid_value< char > invalid_value;

    // Parsing error.
    //
    typedef ::xsd::cxx::parser::error< char > error;
    typedef ::xsd::cxx::parser::errors< char > errors;

    // Read-only string.
    //
    typedef ::xsd::cxx::parser::ro_string< char > ro_string;

    // Parsing flags. See libxsd/xsd/cxx/parser/elements.hxx for details.
    //
    typedef ::xsd::cxx::parser::xerces::flags flags;

    // Parsing properties. See libxsd/xsd/cxx/parser/elements.hxx for details.
    //
    typedef ::xsd::cxx::parser::xerces::properties< char > properties;
  }
}

#include "xml-parser-templates.hxx"

namespace srgs
{
  namespace parser
  {
    namespace templates
    {
      namespace _xsd_tag
      {
        typedef ::xsd::cxx::parser::non_validating::simple_content< char > tag;
      }

      template < typename _xsd_tag_ >
      struct tag:
        virtual ::xsd::cxx::parser::parser< _xsd_tag_, char >,
        virtual _xsd_tag::tag
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();
        virtual _xsd_tag_ post ();

        */
      };

      namespace _xsd_example
      {
        typedef ::xsd::cxx::parser::non_validating::simple_content< char > example;
      }

      template < typename _xsd_example_ >
      struct example:
        virtual ::xsd::cxx::parser::parser< _xsd_example_, char >,
        virtual _xsd_example::example
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();
        virtual _xsd_example_ post ();

        */
      };

      namespace _xsd_Id_datatype
      {
        typedef ::xsd::cxx::parser::non_validating::simple_content< char > Id_datatype;
      }

      template < typename _xsd_Id_datatype_ >
      struct Id_datatype:
        virtual ::xsd::cxx::parser::parser< _xsd_Id_datatype_, char >,
        virtual _xsd_Id_datatype::Id_datatype
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();
        virtual _xsd_Id_datatype_ post ();

        */
      };

      namespace _xsd_Scope_datatype
      {
        typedef ::xsd::cxx::parser::non_validating::simple_content< char > Scope_datatype;
      }

      template < typename _xsd_Scope_datatype_ >
      struct Scope_datatype:
        virtual ::xsd::cxx::parser::parser< _xsd_Scope_datatype_, char >,
        virtual _xsd_Scope_datatype::Scope_datatype
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();
        virtual _xsd_Scope_datatype_ post ();

        */
      };

      namespace _xsd_Special_datatype
      {
        typedef ::xsd::cxx::parser::non_validating::simple_content< char > Special_datatype;
      }

      template < typename _xsd_Special_datatype_ >
      struct Special_datatype:
        virtual ::xsd::cxx::parser::parser< _xsd_Special_datatype_, char >,
        virtual _xsd_Special_datatype::Special_datatype
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();
        virtual _xsd_Special_datatype_ post ();

        */
      };

      namespace _xsd_Repeat_prob_datatype
      {
        typedef ::xsd::cxx::parser::non_validating::simple_content< char > Repeat_prob_datatype;
      }

      template < typename _xsd_Repeat_prob_datatype_ >
      struct Repeat_prob_datatype:
        virtual ::xsd::cxx::parser::parser< _xsd_Repeat_prob_datatype_, char >,
        virtual _xsd_Repeat_prob_datatype::Repeat_prob_datatype
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();
        virtual _xsd_Repeat_prob_datatype_ post ();

        */
      };

      namespace _xsd_Repeat_datatype
      {
        typedef ::xsd::cxx::parser::non_validating::simple_content< char > Repeat_datatype;
      }

      template < typename _xsd_Repeat_datatype_ >
      struct Repeat_datatype:
        virtual ::xsd::cxx::parser::parser< _xsd_Repeat_datatype_, char >,
        virtual _xsd_Repeat_datatype::Repeat_datatype
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();
        virtual _xsd_Repeat_datatype_ post ();

        */
      };

      namespace _xsd_Weight_datatype
      {
        typedef ::xsd::cxx::parser::non_validating::simple_content< char > Weight_datatype;
      }

      template < typename _xsd_Weight_datatype_ >
      struct Weight_datatype:
        virtual ::xsd::cxx::parser::parser< _xsd_Weight_datatype_, char >,
        virtual _xsd_Weight_datatype::Weight_datatype
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();
        virtual _xsd_Weight_datatype_ post ();

        */
      };

      namespace _xsd_Tag_format_datatype
      {
        typedef ::xsd::cxx::parser::non_validating::simple_content< char > Tag_format_datatype;
      }

      template < typename _xsd_Tag_format_datatype_ >
      struct Tag_format_datatype:
        virtual ::xsd::cxx::parser::parser< _xsd_Tag_format_datatype_, char >,
        virtual _xsd_Tag_format_datatype::Tag_format_datatype
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();
        virtual _xsd_Tag_format_datatype_ post ();

        */
      };

      namespace _xsd_Version_datatype
      {
        typedef ::xsd::cxx::parser::non_validating::simple_content< char > Version_datatype;
      }

      template < typename _xsd_Version_datatype_ >
      struct Version_datatype:
        virtual ::xsd::cxx::parser::parser< _xsd_Version_datatype_, char >,
        virtual _xsd_Version_datatype::Version_datatype
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();
        virtual _xsd_Version_datatype_ post ();

        */
      };

      namespace _xsd_Root_datatype
      {
        typedef ::xsd::cxx::parser::non_validating::simple_content< char > Root_datatype;
      }

      template < typename _xsd_Root_datatype_ >
      struct Root_datatype:
        virtual ::xsd::cxx::parser::parser< _xsd_Root_datatype_, char >,
        virtual _xsd_Root_datatype::Root_datatype
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();
        virtual _xsd_Root_datatype_ post ();

        */
      };

      namespace _xsd_Mode_datatype
      {
        typedef ::xsd::cxx::parser::non_validating::simple_content< char > Mode_datatype;
      }

      template < typename _xsd_Mode_datatype_ >
      struct Mode_datatype:
        virtual ::xsd::cxx::parser::parser< _xsd_Mode_datatype_, char >,
        virtual _xsd_Mode_datatype::Mode_datatype
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();
        virtual _xsd_Mode_datatype_ post ();

        */
      };

      namespace _xsd_Type_datatype
      {
        typedef ::xsd::cxx::parser::non_validating::simple_content< char > Type_datatype;
      }

      template < typename _xsd_Type_datatype_ >
      struct Type_datatype:
        virtual ::xsd::cxx::parser::parser< _xsd_Type_datatype_, char >,
        virtual _xsd_Type_datatype::Type_datatype
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();
        virtual _xsd_Type_datatype_ post ();

        */
      };

      namespace _xsd_ruleref
      {
        template < typename x >
        struct _xsd_type
        {
          virtual ~_xsd_type ();
          virtual void type (const x&);
          void _xsd_call_glue_type (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_uri
        {
          virtual ~_xsd_uri ();
          virtual void uri (const x&);
          void _xsd_call_glue_uri (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_special
        {
          virtual ~_xsd_special ();
          virtual void special (const x&);
          void _xsd_call_glue_special (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename _xsd_type_, typename _xsd_uri_, typename _xsd_special_ >
        struct ruleref:
          virtual ::xsd::cxx::parser::non_validating::complex_content< char >,
          _xsd_type< _xsd_type_ >,
          _xsd_uri< _xsd_uri_ >,
          _xsd_special< _xsd_special_ >
        {
          // Parser construction API.
          //
          void
          type_parser (::xsd::cxx::parser::parser< _xsd_type_, char >&);

          void
          uri_parser (::xsd::cxx::parser::parser< _xsd_uri_, char >&);

          void
          special_parser (::xsd::cxx::parser::parser< _xsd_special_, char >&);

          void
          parsers (::xsd::cxx::parser::parser< _xsd_type_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_uri_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_special_, char >&);

          ruleref ();


          // Implementation.
          //
          protected:
          virtual bool
          _attribute_impl (const ::xsd::cxx::parser::ro_string< char >&,
                           const ::xsd::cxx::parser::ro_string< char >&,
                           const ::xsd::cxx::parser::ro_string< char >&);

          protected:
          ::xsd::cxx::parser::parser< _xsd_type_, char >* _xsd_type__;
          ::xsd::cxx::parser::parser< _xsd_uri_, char >* _xsd_uri__;
          ::xsd::cxx::parser::parser< _xsd_special_, char >* _xsd_special__;
        };
      }

      template < typename _xsd_ruleref_, typename _xsd_type_, typename _xsd_uri_, typename _xsd_special_ >
      struct ruleref:
        virtual ::xsd::cxx::parser::parser< _xsd_ruleref_, char >,
        virtual _xsd_ruleref::ruleref< _xsd_type_, _xsd_uri_, _xsd_special_ >
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();

        virtual void type (const _xsd_type_&);
        virtual void uri (const _xsd_uri_&);
        virtual void special (const _xsd_special_&);

        virtual _xsd_ruleref_ post ();

        */
      };

      namespace _xsd_token
      {
        template < typename x >
        struct _xsd_lang
        {
          virtual ~_xsd_lang ();
          virtual void lang (const x&);
          void _xsd_call_glue_lang (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename _xsd_lang_ >
        struct token:
          virtual ::xsd::cxx::parser::non_validating::complex_content< char >,
          _xsd_lang< _xsd_lang_ >
        {
          // Parser construction API.
          //
          void
          lang_parser (::xsd::cxx::parser::parser< _xsd_lang_, char >&);

          void
          parsers (::xsd::cxx::parser::parser< _xsd_lang_, char >&);

          token ();


          // Implementation.
          //
          protected:
          virtual bool
          _attribute_impl (const ::xsd::cxx::parser::ro_string< char >&,
                           const ::xsd::cxx::parser::ro_string< char >&,
                           const ::xsd::cxx::parser::ro_string< char >&);

          protected:
          ::xsd::cxx::parser::parser< _xsd_lang_, char >* _xsd_lang__;
        };
      }

      template < typename _xsd_token_, typename _xsd_lang_ >
      struct token:
        virtual ::xsd::cxx::parser::parser< _xsd_token_, char >,
        virtual _xsd_token::token< _xsd_lang_ >
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();

        virtual void lang (const _xsd_lang_&);

        virtual _xsd_token_ post ();

        */
      };

      namespace _xsd_one_of
      {
        template < typename x >
        struct _xsd_item
        {
          virtual ~_xsd_item ();
          virtual void item (const x&);
          void _xsd_call_glue_item (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_lang
        {
          virtual ~_xsd_lang ();
          virtual void lang (const x&);
          void _xsd_call_glue_lang (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename _xsd_item_, typename _xsd_lang_ >
        struct one_of:
          virtual ::xsd::cxx::parser::non_validating::complex_content< char >,
          _xsd_item< _xsd_item_ >,
          _xsd_lang< _xsd_lang_ >
        {
          // Parser construction API.
          //
          void
          item_parser (::xsd::cxx::parser::parser< _xsd_item_, char >&);

          void
          lang_parser (::xsd::cxx::parser::parser< _xsd_lang_, char >&);

          void
          parsers (::xsd::cxx::parser::parser< _xsd_item_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_lang_, char >&);

          one_of ();


          // Implementation.
          //
          protected:
          virtual bool
          _start_element_impl (const ::xsd::cxx::parser::ro_string< char >&,
                               const ::xsd::cxx::parser::ro_string< char >&);

          virtual bool
          _end_element_impl (const ::xsd::cxx::parser::ro_string< char >&,
                             const ::xsd::cxx::parser::ro_string< char >&);

          virtual bool
          _attribute_impl (const ::xsd::cxx::parser::ro_string< char >&,
                           const ::xsd::cxx::parser::ro_string< char >&,
                           const ::xsd::cxx::parser::ro_string< char >&);

          protected:
          ::xsd::cxx::parser::parser< _xsd_item_, char >* _xsd_item__;
          ::xsd::cxx::parser::parser< _xsd_lang_, char >* _xsd_lang__;
        };
      }

      template < typename _xsd_one_of_, typename _xsd_item_, typename _xsd_lang_ >
      struct one_of:
        virtual ::xsd::cxx::parser::parser< _xsd_one_of_, char >,
        virtual _xsd_one_of::one_of< _xsd_item_, _xsd_lang_ >
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();

        virtual void item (const _xsd_item_&);
        virtual void lang (const _xsd_lang_&);

        virtual _xsd_one_of_ post ();

        */
      };

      namespace _xsd_item
      {
        template < typename x >
        struct _xsd_token
        {
          virtual ~_xsd_token ();
          virtual void token (const x&);
          void _xsd_call_glue_token (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_ruleref
        {
          virtual ~_xsd_ruleref ();
          virtual void ruleref (const x&);
          void _xsd_call_glue_ruleref (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_item1
        {
          virtual ~_xsd_item1 ();
          virtual void item1 (const x&);
          void _xsd_call_glue_item1 (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_one_of
        {
          virtual ~_xsd_one_of ();
          virtual void one_of (const x&);
          void _xsd_call_glue_one_of (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_tag
        {
          virtual ~_xsd_tag ();
          virtual void tag (const x&);
          void _xsd_call_glue_tag (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_repeat_prob
        {
          virtual ~_xsd_repeat_prob ();
          virtual void repeat_prob (const x&);
          void _xsd_call_glue_repeat_prob (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_repeat
        {
          virtual ~_xsd_repeat ();
          virtual void repeat (const x&);
          void _xsd_call_glue_repeat (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_weight
        {
          virtual ~_xsd_weight ();
          virtual void weight (const x&);
          void _xsd_call_glue_weight (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_lang
        {
          virtual ~_xsd_lang ();
          virtual void lang (const x&);
          void _xsd_call_glue_lang (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename _xsd_token_, typename _xsd_ruleref_, typename _xsd_item1_, typename _xsd_one_of_, typename _xsd_tag_, typename _xsd_repeat_prob_, typename _xsd_repeat_, typename _xsd_weight_, typename _xsd_lang_ >
        struct item:
          virtual ::xsd::cxx::parser::non_validating::complex_content< char >,
          _xsd_token< _xsd_token_ >,
          _xsd_ruleref< _xsd_ruleref_ >,
          _xsd_item1< _xsd_item1_ >,
          _xsd_one_of< _xsd_one_of_ >,
          _xsd_tag< _xsd_tag_ >,
          _xsd_repeat_prob< _xsd_repeat_prob_ >,
          _xsd_repeat< _xsd_repeat_ >,
          _xsd_weight< _xsd_weight_ >,
          _xsd_lang< _xsd_lang_ >
        {
          // Parser construction API.
          //
          void
          token_parser (::xsd::cxx::parser::parser< _xsd_token_, char >&);

          void
          ruleref_parser (::xsd::cxx::parser::parser< _xsd_ruleref_, char >&);

          void
          item1_parser (::xsd::cxx::parser::parser< _xsd_item1_, char >&);

          void
          one_of_parser (::xsd::cxx::parser::parser< _xsd_one_of_, char >&);

          void
          tag_parser (::xsd::cxx::parser::parser< _xsd_tag_, char >&);

          void
          repeat_prob_parser (::xsd::cxx::parser::parser< _xsd_repeat_prob_, char >&);

          void
          repeat_parser (::xsd::cxx::parser::parser< _xsd_repeat_, char >&);

          void
          weight_parser (::xsd::cxx::parser::parser< _xsd_weight_, char >&);

          void
          lang_parser (::xsd::cxx::parser::parser< _xsd_lang_, char >&);

          void
          parsers (::xsd::cxx::parser::parser< _xsd_token_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_ruleref_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_item1_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_one_of_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_tag_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_repeat_prob_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_repeat_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_weight_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_lang_, char >&);

          item ();


          // Implementation.
          //
          protected:
          virtual bool
          _start_element_impl (const ::xsd::cxx::parser::ro_string< char >&,
                               const ::xsd::cxx::parser::ro_string< char >&);

          virtual bool
          _end_element_impl (const ::xsd::cxx::parser::ro_string< char >&,
                             const ::xsd::cxx::parser::ro_string< char >&);

          virtual bool
          _attribute_impl (const ::xsd::cxx::parser::ro_string< char >&,
                           const ::xsd::cxx::parser::ro_string< char >&,
                           const ::xsd::cxx::parser::ro_string< char >&);

          protected:
          ::xsd::cxx::parser::parser< _xsd_token_, char >* _xsd_token__;
          ::xsd::cxx::parser::parser< _xsd_ruleref_, char >* _xsd_ruleref__;
          ::xsd::cxx::parser::parser< _xsd_item1_, char >* _xsd_item1__;
          ::xsd::cxx::parser::parser< _xsd_one_of_, char >* _xsd_one_of__;
          ::xsd::cxx::parser::parser< _xsd_tag_, char >* _xsd_tag__;
          ::xsd::cxx::parser::parser< _xsd_repeat_prob_, char >* _xsd_repeat_prob__;
          ::xsd::cxx::parser::parser< _xsd_repeat_, char >* _xsd_repeat__;
          ::xsd::cxx::parser::parser< _xsd_weight_, char >* _xsd_weight__;
          ::xsd::cxx::parser::parser< _xsd_lang_, char >* _xsd_lang__;
        };
      }

      template < typename _xsd_item_, typename _xsd_token_, typename _xsd_ruleref_, typename _xsd_item1_, typename _xsd_one_of_, typename _xsd_tag_, typename _xsd_repeat_prob_, typename _xsd_repeat_, typename _xsd_weight_, typename _xsd_lang_ >
      struct item:
        virtual ::xsd::cxx::parser::parser< _xsd_item_, char >,
        virtual _xsd_item::item< _xsd_token_, _xsd_ruleref_, _xsd_item1_, _xsd_one_of_, _xsd_tag_, _xsd_repeat_prob_, _xsd_repeat_, _xsd_weight_, _xsd_lang_ >
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();

        virtual void token (const _xsd_token_&);
        virtual void ruleref (const _xsd_ruleref_&);
        virtual void item1 (const _xsd_item1_&);
        virtual void one_of (const _xsd_one_of_&);
        virtual void tag (const _xsd_tag_&);
        virtual void repeat_prob (const _xsd_repeat_prob_&);
        virtual void repeat (const _xsd_repeat_&);
        virtual void weight (const _xsd_weight_&);
        virtual void lang (const _xsd_lang_&);

        virtual _xsd_item_ post ();

        */
      };

      namespace _xsd_rule
      {
        template < typename x >
        struct _xsd_token
        {
          virtual ~_xsd_token ();
          virtual void token (const x&);
          void _xsd_call_glue_token (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_ruleref
        {
          virtual ~_xsd_ruleref ();
          virtual void ruleref (const x&);
          void _xsd_call_glue_ruleref (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_item
        {
          virtual ~_xsd_item ();
          virtual void item (const x&);
          void _xsd_call_glue_item (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_one_of
        {
          virtual ~_xsd_one_of ();
          virtual void one_of (const x&);
          void _xsd_call_glue_one_of (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_tag
        {
          virtual ~_xsd_tag ();
          virtual void tag (const x&);
          void _xsd_call_glue_tag (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_example
        {
          virtual ~_xsd_example ();
          virtual void example (const x&);
          void _xsd_call_glue_example (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_id
        {
          virtual ~_xsd_id ();
          virtual void id (const x&);
          void _xsd_call_glue_id (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_scope
        {
          virtual ~_xsd_scope ();
          virtual void scope (const x&);
          void _xsd_call_glue_scope (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename _xsd_token_, typename _xsd_ruleref_, typename _xsd_item_, typename _xsd_one_of_, typename _xsd_tag_, typename _xsd_example_, typename _xsd_id_, typename _xsd_scope_ >
        struct rule:
          virtual ::xsd::cxx::parser::non_validating::complex_content< char >,
          _xsd_token< _xsd_token_ >,
          _xsd_ruleref< _xsd_ruleref_ >,
          _xsd_item< _xsd_item_ >,
          _xsd_one_of< _xsd_one_of_ >,
          _xsd_tag< _xsd_tag_ >,
          _xsd_example< _xsd_example_ >,
          _xsd_id< _xsd_id_ >,
          _xsd_scope< _xsd_scope_ >
        {
          // Parser construction API.
          //
          void
          token_parser (::xsd::cxx::parser::parser< _xsd_token_, char >&);

          void
          ruleref_parser (::xsd::cxx::parser::parser< _xsd_ruleref_, char >&);

          void
          item_parser (::xsd::cxx::parser::parser< _xsd_item_, char >&);

          void
          one_of_parser (::xsd::cxx::parser::parser< _xsd_one_of_, char >&);

          void
          tag_parser (::xsd::cxx::parser::parser< _xsd_tag_, char >&);

          void
          example_parser (::xsd::cxx::parser::parser< _xsd_example_, char >&);

          void
          id_parser (::xsd::cxx::parser::parser< _xsd_id_, char >&);

          void
          scope_parser (::xsd::cxx::parser::parser< _xsd_scope_, char >&);

          void
          parsers (::xsd::cxx::parser::parser< _xsd_token_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_ruleref_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_item_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_one_of_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_tag_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_example_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_id_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_scope_, char >&);

          rule ();


          // Implementation.
          //
          protected:
          virtual bool
          _start_element_impl (const ::xsd::cxx::parser::ro_string< char >&,
                               const ::xsd::cxx::parser::ro_string< char >&);

          virtual bool
          _end_element_impl (const ::xsd::cxx::parser::ro_string< char >&,
                             const ::xsd::cxx::parser::ro_string< char >&);

          virtual bool
          _attribute_impl (const ::xsd::cxx::parser::ro_string< char >&,
                           const ::xsd::cxx::parser::ro_string< char >&,
                           const ::xsd::cxx::parser::ro_string< char >&);

          protected:
          ::xsd::cxx::parser::parser< _xsd_token_, char >* _xsd_token__;
          ::xsd::cxx::parser::parser< _xsd_ruleref_, char >* _xsd_ruleref__;
          ::xsd::cxx::parser::parser< _xsd_item_, char >* _xsd_item__;
          ::xsd::cxx::parser::parser< _xsd_one_of_, char >* _xsd_one_of__;
          ::xsd::cxx::parser::parser< _xsd_tag_, char >* _xsd_tag__;
          ::xsd::cxx::parser::parser< _xsd_example_, char >* _xsd_example__;
          ::xsd::cxx::parser::parser< _xsd_id_, char >* _xsd_id__;
          ::xsd::cxx::parser::parser< _xsd_scope_, char >* _xsd_scope__;
        };
      }

      template < typename _xsd_rule_, typename _xsd_token_, typename _xsd_ruleref_, typename _xsd_item_, typename _xsd_one_of_, typename _xsd_tag_, typename _xsd_example_, typename _xsd_id_, typename _xsd_scope_ >
      struct rule:
        virtual ::xsd::cxx::parser::parser< _xsd_rule_, char >,
        virtual _xsd_rule::rule< _xsd_token_, _xsd_ruleref_, _xsd_item_, _xsd_one_of_, _xsd_tag_, _xsd_example_, _xsd_id_, _xsd_scope_ >
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();

        virtual void token (const _xsd_token_&);
        virtual void ruleref (const _xsd_ruleref_&);
        virtual void item (const _xsd_item_&);
        virtual void one_of (const _xsd_one_of_&);
        virtual void tag (const _xsd_tag_&);
        virtual void example (const _xsd_example_&);
        virtual void id (const _xsd_id_&);
        virtual void scope (const _xsd_scope_&);

        virtual _xsd_rule_ post ();

        */
      };

      namespace _xsd_lexicon
      {
        template < typename x >
        struct _xsd_uri
        {
          virtual ~_xsd_uri ();
          virtual void uri (const x&);
          void _xsd_call_glue_uri (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_type
        {
          virtual ~_xsd_type ();
          virtual void type (const x&);
          void _xsd_call_glue_type (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename _xsd_uri_, typename _xsd_type_ >
        struct lexicon:
          virtual ::xsd::cxx::parser::non_validating::complex_content< char >,
          _xsd_uri< _xsd_uri_ >,
          _xsd_type< _xsd_type_ >
        {
          // Parser construction API.
          //
          void
          uri_parser (::xsd::cxx::parser::parser< _xsd_uri_, char >&);

          void
          type_parser (::xsd::cxx::parser::parser< _xsd_type_, char >&);

          void
          parsers (::xsd::cxx::parser::parser< _xsd_uri_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_type_, char >&);

          lexicon ();


          // Implementation.
          //
          protected:
          virtual bool
          _attribute_impl (const ::xsd::cxx::parser::ro_string< char >&,
                           const ::xsd::cxx::parser::ro_string< char >&,
                           const ::xsd::cxx::parser::ro_string< char >&);

          protected:
          ::xsd::cxx::parser::parser< _xsd_uri_, char >* _xsd_uri__;
          ::xsd::cxx::parser::parser< _xsd_type_, char >* _xsd_type__;
        };
      }

      template < typename _xsd_lexicon_, typename _xsd_uri_, typename _xsd_type_ >
      struct lexicon:
        virtual ::xsd::cxx::parser::parser< _xsd_lexicon_, char >,
        virtual _xsd_lexicon::lexicon< _xsd_uri_, _xsd_type_ >
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();

        virtual void uri (const _xsd_uri_&);
        virtual void type (const _xsd_type_&);

        virtual _xsd_lexicon_ post ();

        */
      };

      namespace _xsd_meta
      {
        template < typename x >
        struct _xsd_name
        {
          virtual ~_xsd_name ();
          virtual void name (const x&);
          void _xsd_call_glue_name (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_content
        {
          virtual ~_xsd_content ();
          virtual void content (const x&);
          void _xsd_call_glue_content (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_http_equiv
        {
          virtual ~_xsd_http_equiv ();
          virtual void http_equiv (const x&);
          void _xsd_call_glue_http_equiv (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename _xsd_name_, typename _xsd_content_, typename _xsd_http_equiv_ >
        struct meta:
          virtual ::xsd::cxx::parser::non_validating::complex_content< char >,
          _xsd_name< _xsd_name_ >,
          _xsd_content< _xsd_content_ >,
          _xsd_http_equiv< _xsd_http_equiv_ >
        {
          // Parser construction API.
          //
          void
          name_parser (::xsd::cxx::parser::parser< _xsd_name_, char >&);

          void
          content_parser (::xsd::cxx::parser::parser< _xsd_content_, char >&);

          void
          http_equiv_parser (::xsd::cxx::parser::parser< _xsd_http_equiv_, char >&);

          void
          parsers (::xsd::cxx::parser::parser< _xsd_name_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_content_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_http_equiv_, char >&);

          meta ();


          // Implementation.
          //
          protected:
          virtual bool
          _attribute_impl (const ::xsd::cxx::parser::ro_string< char >&,
                           const ::xsd::cxx::parser::ro_string< char >&,
                           const ::xsd::cxx::parser::ro_string< char >&);

          protected:
          ::xsd::cxx::parser::parser< _xsd_name_, char >* _xsd_name__;
          ::xsd::cxx::parser::parser< _xsd_content_, char >* _xsd_content__;
          ::xsd::cxx::parser::parser< _xsd_http_equiv_, char >* _xsd_http_equiv__;
        };
      }

      template < typename _xsd_meta_, typename _xsd_name_, typename _xsd_content_, typename _xsd_http_equiv_ >
      struct meta:
        virtual ::xsd::cxx::parser::parser< _xsd_meta_, char >,
        virtual _xsd_meta::meta< _xsd_name_, _xsd_content_, _xsd_http_equiv_ >
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();

        virtual void name (const _xsd_name_&);
        virtual void content (const _xsd_content_&);
        virtual void http_equiv (const _xsd_http_equiv_&);

        virtual _xsd_meta_ post ();

        */
      };

      namespace _xsd_metadata
      {
        typedef ::xsd::cxx::parser::non_validating::complex_content< char > metadata;
      }

      template < typename _xsd_metadata_ >
      struct metadata:
        virtual ::xsd::cxx::parser::parser< _xsd_metadata_, char >,
        virtual _xsd_metadata::metadata
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();
        virtual _xsd_metadata_ post ();

        */
      };

      namespace _xsd_grammar
      {
        template < typename x >
        struct _xsd_rule
        {
          virtual ~_xsd_rule ();
          virtual void rule (const x&);
          void _xsd_call_glue_rule (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_lexicon
        {
          virtual ~_xsd_lexicon ();
          virtual void lexicon (const x&);
          void _xsd_call_glue_lexicon (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_meta
        {
          virtual ~_xsd_meta ();
          virtual void meta (const x&);
          void _xsd_call_glue_meta (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_metadata
        {
          virtual ~_xsd_metadata ();
          virtual void metadata (const x&);
          void _xsd_call_glue_metadata (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_tag
        {
          virtual ~_xsd_tag ();
          virtual void tag (const x&);
          void _xsd_call_glue_tag (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_tag_format
        {
          virtual ~_xsd_tag_format ();
          virtual void tag_format (const x&);
          void _xsd_call_glue_tag_format (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_version
        {
          virtual ~_xsd_version ();
          virtual void version (const x&);
          void _xsd_call_glue_version (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_lang
        {
          virtual ~_xsd_lang ();
          virtual void lang (const x&);
          void _xsd_call_glue_lang (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_base
        {
          virtual ~_xsd_base ();
          virtual void base (const x&);
          void _xsd_call_glue_base (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_root
        {
          virtual ~_xsd_root ();
          virtual void root (const x&);
          void _xsd_call_glue_root (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename x >
        struct _xsd_mode
        {
          virtual ~_xsd_mode ();
          virtual void mode (const x&);
          void _xsd_call_glue_mode (::xsd::cxx::parser::parser< x, char >*);
        };

        template < typename _xsd_rule_, typename _xsd_lexicon_, typename _xsd_meta_, typename _xsd_metadata_, typename _xsd_tag_, typename _xsd_tag_format_, typename _xsd_version_, typename _xsd_lang_, typename _xsd_base_, typename _xsd_root_, typename _xsd_mode_ >
        struct grammar:
          virtual ::xsd::cxx::parser::non_validating::complex_content< char >,
          _xsd_rule< _xsd_rule_ >,
          _xsd_lexicon< _xsd_lexicon_ >,
          _xsd_meta< _xsd_meta_ >,
          _xsd_metadata< _xsd_metadata_ >,
          _xsd_tag< _xsd_tag_ >,
          _xsd_tag_format< _xsd_tag_format_ >,
          _xsd_version< _xsd_version_ >,
          _xsd_lang< _xsd_lang_ >,
          _xsd_base< _xsd_base_ >,
          _xsd_root< _xsd_root_ >,
          _xsd_mode< _xsd_mode_ >
        {
          // Parser construction API.
          //
          void
          rule_parser (::xsd::cxx::parser::parser< _xsd_rule_, char >&);

          void
          lexicon_parser (::xsd::cxx::parser::parser< _xsd_lexicon_, char >&);

          void
          meta_parser (::xsd::cxx::parser::parser< _xsd_meta_, char >&);

          void
          metadata_parser (::xsd::cxx::parser::parser< _xsd_metadata_, char >&);

          void
          tag_parser (::xsd::cxx::parser::parser< _xsd_tag_, char >&);

          void
          tag_format_parser (::xsd::cxx::parser::parser< _xsd_tag_format_, char >&);

          void
          version_parser (::xsd::cxx::parser::parser< _xsd_version_, char >&);

          void
          lang_parser (::xsd::cxx::parser::parser< _xsd_lang_, char >&);

          void
          base_parser (::xsd::cxx::parser::parser< _xsd_base_, char >&);

          void
          root_parser (::xsd::cxx::parser::parser< _xsd_root_, char >&);

          void
          mode_parser (::xsd::cxx::parser::parser< _xsd_mode_, char >&);

          void
          parsers (::xsd::cxx::parser::parser< _xsd_rule_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_lexicon_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_meta_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_metadata_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_tag_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_tag_format_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_version_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_lang_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_base_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_root_, char >&,
                   ::xsd::cxx::parser::parser< _xsd_mode_, char >&);

          grammar ();


          // Implementation.
          //
          protected:
          virtual bool
          _start_element_impl (const ::xsd::cxx::parser::ro_string< char >&,
                               const ::xsd::cxx::parser::ro_string< char >&);

          virtual bool
          _end_element_impl (const ::xsd::cxx::parser::ro_string< char >&,
                             const ::xsd::cxx::parser::ro_string< char >&);

          virtual bool
          _attribute_impl (const ::xsd::cxx::parser::ro_string< char >&,
                           const ::xsd::cxx::parser::ro_string< char >&,
                           const ::xsd::cxx::parser::ro_string< char >&);

          protected:
          ::xsd::cxx::parser::parser< _xsd_rule_, char >* _xsd_rule__;
          ::xsd::cxx::parser::parser< _xsd_lexicon_, char >* _xsd_lexicon__;
          ::xsd::cxx::parser::parser< _xsd_meta_, char >* _xsd_meta__;
          ::xsd::cxx::parser::parser< _xsd_metadata_, char >* _xsd_metadata__;
          ::xsd::cxx::parser::parser< _xsd_tag_, char >* _xsd_tag__;
          ::xsd::cxx::parser::parser< _xsd_tag_format_, char >* _xsd_tag_format__;
          ::xsd::cxx::parser::parser< _xsd_version_, char >* _xsd_version__;
          ::xsd::cxx::parser::parser< _xsd_lang_, char >* _xsd_lang__;
          ::xsd::cxx::parser::parser< _xsd_base_, char >* _xsd_base__;
          ::xsd::cxx::parser::parser< _xsd_root_, char >* _xsd_root__;
          ::xsd::cxx::parser::parser< _xsd_mode_, char >* _xsd_mode__;
        };
      }

      template < typename _xsd_grammar_, typename _xsd_rule_, typename _xsd_lexicon_, typename _xsd_meta_, typename _xsd_metadata_, typename _xsd_tag_, typename _xsd_tag_format_, typename _xsd_version_, typename _xsd_lang_, typename _xsd_base_, typename _xsd_root_, typename _xsd_mode_ >
      struct grammar:
        virtual ::xsd::cxx::parser::parser< _xsd_grammar_, char >,
        virtual _xsd_grammar::grammar< _xsd_rule_, _xsd_lexicon_, _xsd_meta_, _xsd_metadata_, _xsd_tag_, _xsd_tag_format_, _xsd_version_, _xsd_lang_, _xsd_base_, _xsd_root_, _xsd_mode_ >
      {
        /*

        Parser hooks. Override them in your implementation.

        virtual void pre ();

        virtual void rule (const _xsd_rule_&);
        virtual void lexicon (const _xsd_lexicon_&);
        virtual void meta (const _xsd_meta_&);
        virtual void metadata (const _xsd_metadata_&);
        virtual void tag (const _xsd_tag_&);
        virtual void tag_format (const _xsd_tag_format_&);
        virtual void version (const _xsd_version_&);
        virtual void lang (const _xsd_lang_&);
        virtual void base (const _xsd_base_&);
        virtual void root (const _xsd_root_&);
        virtual void mode (const _xsd_mode_&);

        virtual _xsd_grammar_ post ();

        */
      };
    }
  }
}

#include "srgs-parser-templates.ixx"
#include "srgs-parser-templates.txx"

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // SRGS_PARSER_TEMPLATES_HXX
