// Copyright (C) 2005-2006 Code Synthesis Tools CC
//
// This program was generated by XML Schema Definition Compiler (XSD)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
// In addition, as a special exception, Code Synthesis Tools CC gives
// permission to link this program with the Xerces-C++ library (or with
// modified versions of Xerces-C++ that use the same license as Xerces-C++),
// and distribute linked combinations including the two. You must obey
// the GNU General Public License version 2 in all respects for all of
// the code used other than Xerces-C++. If you modify this copy of the
// program, you may extend this exception to your version of the program,
// but you are not obligated to do so. If you do not wish to do so, delete
// this exception statement from your version.
//
// In addition, Code Synthesis Tools CC makes a special exception for
// the Free/Libre and Open Source Software (FLOSS) which is described
// in the accompanying FLOSSE file.
//

#ifndef XML_HXX
#define XML_HXX

#include <xsd/cxx/version.hxx>

#if (XSD_INT_VERSION != 2030051L)
#error XSD runtime version mismatch
#endif

// Begin prologue.
//
//
// End prologue.

#include <xsd/cxx/pre.hxx>

#ifndef XSD_USE_CHAR
#define XSD_USE_CHAR
#endif

#ifndef XSD_CXX_PARSER_USE_CHAR
#define XSD_CXX_PARSER_USE_CHAR
#endif

#include <xsd/cxx/parser/exceptions.hxx>
#include <xsd/cxx/parser/elements.hxx>
#include <xsd/cxx/parser/non-validating/parser.hxx>
#include <xsd/cxx/parser/non-validating/types.hxx>
#include <xsd/cxx/parser/xerces/elements.hxx>

namespace xml_schema
{
  namespace parser
  {
    // Generic parser.
    //
#ifndef XSD_CXX_PARSER_XERCES_CHAR_PARSER_IN___XML_SCHEMA__PARSER
#define XSD_CXX_PARSER_XERCES_CHAR_PARSER_IN___XML_SCHEMA__PARSER

    template <typename X>
    struct parser: virtual ::xsd::cxx::parser::parser< X, char >,
    virtual ::xsd::cxx::parser::non_validating::empty_content< char >
    {
    };

    template <typename X>
    struct document: ::xsd::cxx::parser::xerces::document< X, char >
    {
      document (::xsd::cxx::parser::parser< X, char >& p,
                const ::std::basic_string< char >& root_element_name)
      : ::xsd::cxx::parser::xerces::document< X, char > (
        p,
        root_element_name)
      {
      }

      document (::xsd::cxx::parser::parser< X, char >& p,
                const ::std::basic_string< char >& root_element_namespace,
                const ::std::basic_string< char >& root_element_name)
      : ::xsd::cxx::parser::xerces::document< X, char > (
        p,
        root_element_namespace,
        root_element_name)
      {
      }
    };

#endif

    // Parsers for XML Schema built-in types.
    //

    // 8-bit
    //
    typedef ::xsd::cxx::parser::non_validating::byte< char > byte;
    typedef ::xsd::cxx::parser::non_validating::unsigned_byte< char > unsigned_byte;

    // 16-bit
    //
    typedef ::xsd::cxx::parser::non_validating::short_< char > short_;
    typedef ::xsd::cxx::parser::non_validating::unsigned_short< char > unsigned_short;

    // 32-bit
    //
    typedef ::xsd::cxx::parser::non_validating::int_< char > int_;
    typedef ::xsd::cxx::parser::non_validating::unsigned_int< char > unsigned_int;

    // 64-bit
    //
    typedef ::xsd::cxx::parser::non_validating::long_< char > long_;
    typedef ::xsd::cxx::parser::non_validating::unsigned_long< char > unsigned_long;

    // Boolean.
    //
    typedef ::xsd::cxx::parser::non_validating::boolean< char > boolean;

    // Floating-point types.
    //
    typedef ::xsd::cxx::parser::non_validating::float_< char > float_;
    typedef ::xsd::cxx::parser::non_validating::double_< char > double_;
    typedef ::xsd::cxx::parser::non_validating::decimal< char > decimal;

    // String.
    //
    typedef ::xsd::cxx::parser::non_validating::string< char > string;

    // Exceptions. See libxsd/xsd/cxx/parser/exceptions.hxx for details.
    //
    typedef ::xsd::cxx::parser::exception< char > exception;
    typedef ::xsd::cxx::parser::parsing< char > parsing;
    typedef ::xsd::cxx::parser::expected_element< char > expected_element;
    typedef ::xsd::cxx::parser::unexpected_element< char > unexpected_element;
    typedef ::xsd::cxx::parser::expected_attribute< char > expected_attribute;
    typedef ::xsd::cxx::parser::unexpected_attribute< char > unexpected_attribute;
    typedef ::xsd::cxx::parser::unexpected_characters< char > unexpected_characters;
    typedef ::xsd::cxx::parser::invalid_value< char > invalid_value;

    // Parsing error.
    //
    typedef ::xsd::cxx::parser::error< char > error;
    typedef ::xsd::cxx::parser::errors< char > errors;

    // Read-only string.
    //
    typedef ::xsd::cxx::parser::ro_string< char > ro_string;

    // Parsing flags. See libxsd/xsd/cxx/parser/elements.hxx for details.
    //
    typedef ::xsd::cxx::parser::xerces::flags flags;

    // Parsing properties. See libxsd/xsd/cxx/parser/elements.hxx for details.
    //
    typedef ::xsd::cxx::parser::xerces::properties< char > properties;
  }
}

namespace namespace_
{
  template < typename _xsd_lang_ >
  struct lang: virtual ::xsd::cxx::parser::parser< _xsd_lang_, char >
  {
    /*

    Parser hooks. Override them in your implementation.

    virtual void pre ();

    virtual void _characters (const ::xsd::cxx::parser::ro_string< char >&);

    virtual _xsd_lang_ post ();

    */
  };

  namespace _xsd_space
  {
    typedef ::xsd::cxx::parser::non_validating::simple_content< char > space;
  }

  template < typename _xsd_space_ >
  struct space:
    virtual ::xsd::cxx::parser::parser< _xsd_space_, char >,
    virtual _xsd_space::space
  {
    /*

    Parser hooks. Override them in your implementation.

    virtual void pre ();
    virtual _xsd_space_ post ();

    */
  };
}

#include "xml.ixx"
#include "xml.txx"

#include <xsd/cxx/post.hxx>

// Begin epilogue.
//
//
// End epilogue.

#endif // XML_HXX
